<template>
    <div v-if="isLoaded" class="loading-container" style="height: 70vh">
        <div class="loading-box"></div>
    </div>
    <div v-else>
        <div v-if="channel">
            <div class="header-page">
                <div class="title">{{ channel.name}}</div>
                <div class="options">
                    <div v-if="channel.favorite" class="btn btn-primary btn-favorite" title="Удалить из избранных" @click="removeFavorite"><i class="fas fa-star"></i></div>
                    <div v-else class="btn btn-default btn-favorite" title="Добавить в избранные" @click="addFavorite"><i class="far fa-star"></i></div>
                </div>
            </div>
            <div class="body-page">
                <div class="view-video" id="viewChannel">
                    <channel-player :link="channel.link" :archive="channel.archive" :range="channel.archive_range" @timeshift="timeshiftLink" @online="online" @statistic="sendStatistics"></channel-player>

                    <div class="claim">
                        <div class="btn" @click="showModal = true">Оставить жалобу</div>
                    </div>

                    <div v-if="channel.epg.length && !this.$store.state.isLoading" class="info">
                        <div class="list-programs">
                            <div class="tab-menu">
                                <div class="tab-menu-item" :class="tab === 1 ? 'active' : '' " @click="tab = 1">Вчера</div>
                                <div class="tab-menu-item" :class="tab === 2 ? 'active' : '' " @click="tab = 2">Сегодня</div>
                                <div class="tab-menu-item" :class="tab === 3 ? 'active' : '' " @click="tab = 3">Завтра</div>
                            </div>
                            <div class="tab-body">
                                <div class="item-tab list-program" v-if="tab === 1">
                                    <div class="item-program" v-for="program in channel.epg" v-if="program.start < today">
                                        <span class="time">{{ program.start  | moment("HH:mm") }}</span> <span class="title">{{program.name}} </span>
                                        <div class="play-icon"> <router-link  :to="{name: 'Timeshift', params: { name: program.name, id: program.id, channel_id: channel.id }}" class="icon icon-play" v-if="program.in_archive === 1"></router-link> </div>
                                    </div>
                                </div>
                                <div class="item-tab list-program" v-if="tab === 2">
                                    <div class="item-program" v-for="program in channel.epg" v-if="program.start >= today && program.start < today+(3600*24)">
                                        <span class="time">{{ program.start  | moment("HH:mm") }}</span> <span class="title">{{program.name}}</span>
                                        <div class="play-icon"> <router-link  :to="{name: 'Timeshift', params: { name: program.name, id: program.id, channel_id: channel.id }}" class="icon icon-play" v-if="program.in_archive === 1"></router-link> </div>
                                    </div>
                                </div>
                                <div class="item-tab list-program" v-if="tab === 3">
                                    <div class="item-program" v-for="program in channel.epg" v-if="program.start > today+(3600*24)">
                                        <span class="time">{{ program.start  | moment("HH:mm") }}</span> <span class="title">{{program.name}}</span>
                                        <div class="play-icon"> <router-link  :to="{name: 'Timeshift', params: { name: program.name, id: program.id, channel_id: channel.id }}" class="icon icon-play" v-if="program.in_archive === 1"></router-link> </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

            </div>
        </div>

        <div class="modal" v-if="showModal">
            <div class="back-modal" @click="showModal = false"></div>
            <div class="body-claim" v-if="!sendClaim">
                <h4>Возникли проблемы?</h4>
                <h4>Сообщите нам об этом!</h4>
                <div class="list-form">
                    <div class="item-form">
                        <div class="label">Видео</div>
                        <div class="value">
                            <div class="radio">
                                <input type="radio" id="vGood" value="good" v-model="claim.video">
                                <label for="vGood">Хорошо</label>
                            </div>
                            <div class="radio">
                                <input type="radio" id="vBad" value="bad" v-model="claim.video">
                                <label for="vBad">Плохо</label>
                            </div>
                        </div>
                    </div>
                    <div class="item-form">
                        <div class="label">Аудио</div>
                        <div class="value">
                            <div class="radio">
                                <input type="radio" id="sGood" value="good" v-model="claim.sound">
                                <label for="sGood">Хорошо</label>
                            </div>
                            <div class="radio">
                                <input type="radio" id="sBad" value="bad" v-model="claim.sound">
                                <label for="sBad">Плохо</label>
                            </div>
                        </div>
                    </div>
                    <div class="item-form">
                        <div class="label">Телерограма</div>
                        <div class="value">
<!--                            <div class="radio">-->
<!--                                <input type="radio" id="pGood" value="good" v-model="claim.sound">-->
<!--                                <label for="pGood">Хорошо</label>-->
<!--                            </div>-->
                            <div class="radio">
                                <input type="radio" id="pWrong" value="wrong" v-model="claim.epg">
                                <label for="pWrong">Не совпадает</label>
                            </div>
                            <div class="radio">
                                <input type="radio" id="pNo" value="no" v-model="claim.epg">
                                <label for="pNo">Отсутствует</label>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="bottom-form">
                    <div class="btn" @click="sendMyClaim">Сообщить</div>
                </div>
            </div>
            <div class="body-claim" v-else>
                <h4>Спасибо, Ваша оценка учтена!</h4>
                <div class="bottom-form">
                    <div class="btn" @click="clearForm">Закрыть</div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
    import ChannelPlayer from "@/components/players/ChannelPlayer";

    export default {
        name: "ChannelView",
        components: {ChannelPlayer},
        data() {
            return {
                tab: 2,
                sendClaim: false,
                showModal: false,
                statisticFlag: false,
                claim: {
                    sound:  'good',
                    video:  'good',
                    epg:    'good',
                }
            };
        },
        computed: {
            channel() {
                return this.$store.getters.getChannel(this.$route.params.id);
            },
            startTime() {
                return this.$store.state.startTime;
            },
            isLoaded() {
                return this.$store.getters.isLoading('channel');
            },
            today() {
                let currentDate = new Date(),
                    date = currentDate.getDate(),
                    month = currentDate.getMonth(),
                    year = currentDate.getFullYear(),
                    today = new Date(year, month, date, 0, 0 ,0);

                return today.getTime()/1000;
            }
        },
        methods: {
            addFavorite() {
                this.$store.dispatch('addFavoriteChannels', this.channel.id );
            },
            removeFavorite() {
                this.$store.dispatch('removeFavoriteChannels', this.channel.id );
            },
            sendMyClaim() {
                this.sendClaim = true;
                this.$store.dispatch('sendClaim', {id: this.channel.id, claim: this.claim});
            },
            timeshiftLink(duration) {
                console.log('this.startTime',this.startTime);
                if (this.startTime) {
                    let time = Math.floor( (Date.now() - this.startTime)/1000 );
                    if (time >= 10 ){
                        let params = {
                            id: parseInt(this.channel.id),
                            uid: this.$store.state.User.id,
                            sec: time
                        };
                        this.$store.dispatch('sendStatisticTimeshift', params);
                    }
                }
                this.$store.dispatch('loadTimeshiftLink',{id:this.$route.params.id, start:duration});
            },
            online() {
                if (this.startTime) {
                    let time = Math.floor( (Date.now() - this.startTime)/1000 );
                    if (time >= 10 ){
                        let params = {
                            id: parseInt(this.channel.id),
                            uid: this.$store.state.User.id,
                            sec: time
                        };
                        this.$store.dispatch('sendStatisticTimeshift', params);
                    }
                    this.$store.dispatch('clearStartTime');
                }
                this.$store.dispatch('loadChannelLink',this.$route.params.id);
            },
            clearForm() {
                this.sendClaim = false;
                this.showModal = false;
                this.claim.video = 'good';
                this.claim.sound = 'good';
                this.claim.epg   = 'good';
            },
            sendStatistics() {
                if (!this.statisticFlag) {
                    this.statisticFlag = true;
                    let self = this;
                    setTimeout(function () {
                        self.dispatchStatistic();
                    }, 600000)
                }
            },
            dispatchStatistic() {
                let params = {
                    id: parseInt(this.channel.id),
                    uid: this.$store.state.User.id
                };
                this.$store.dispatch('sendStatisticTV', params);
            }
        },
        beforeMount() {
            this.$store.dispatch('loadChannelInfo',this.$route.params.id);
        },
        beforeRouteLeave (to, from, next) {
            if (this.startTime) {
                let time = Math.floor( (Date.now() - this.startTime)/1000 );
                if (time >= 10 ){
                    let params = {
                        id: parseInt(this.channel.id),
                        uid: this.$store.state.User.id,
                        sec: time
                    };
                    this.$store.dispatch('sendStatisticTimeshift', params);
                }
                this.$store.dispatch('clearStartTime');
            }
            next()
        }
    }
</script>

<style scoped lang="scss">

    .claim {
        margin-top: 15px
    }
    .btn {
        border: 1px solid #fff
    }
    .light .btn {
        border: 1px solid #a9c8e6
    }
    .modal {
        position: fixed;
        top: 0;
        left: 0;
        width: 100%;
        height: 100%;
        z-index: 9999999;
        display: flex;
        align-items: center;
        justify-content: center;
        overflow: auto;
        padding: 20px;

        .bottom-form {
            margin-top:20px;
        }

        .back-modal {
            position: absolute;
            top: 0;
            left: 0;
            width: 100%;
            height: 100%;
            z-index: 1;
            background: rgba(255, 255, 255, 0.5);
        }

        .body-claim {
            position: relative;
            z-index: 100;
            padding: 20px;
            background: #0E202C;
            color: #fff;
            text-align: center;

            h4 {
                margin-bottom: 10px;
                line-height: 1;
                font-family: NS-B, serif;
            }

            .list-form {
                text-align: left;
                margin-top: 15px;

                .item-form {
                    margin-bottom: 12px;

                    .label {
                        font-weight: 900;
                        font-size: 18px;
                        margin-bottom: 8px;
                    }
                    .value {
                        display: flex;
                        align-items: center;

                        .radio {
                            width: 50%;

                            input[type="radio"] {
                                display: none;
                            }
                            input[type="radio"] + label {
                                display: flex;
                                align-items: center;

                                &:before {
                                    content: '';
                                    display: block;
                                    min-width: 15px;
                                    max-width: 15px;
                                    height: 15px;
                                    border: 2px solid #fff;
                                    border-radius: 50%;
                                    margin-right: 7px;
                                    box-shadow:
                                            inset 0 0 0 4px #fff,
                                            inset 0 0 0 8px #fff;
                                }
                            }
                            input[type="radio"]:checked + label {

                                &:before {
                                    background: #000;
                                    box-shadow:
                                            inset 0 0 0 4px #0E202C,
                                            inset 0 0 0 8px #fff;
                                }
                            }
                        }
                    }
                }
            }
        }

    }

    .tab-menu {
        display: flex;
        justify-content: flex-start;
    }
    .tab-menu .tab-menu-item {
        display: flex;
        align-items: center;
        padding: 10px 20px;
        margin: 0 5px 0 0;
        border-bottom: 2px solid #fff;
        cursor: pointer;
        font-family: Gil-SB, serif;
    }
    .tab-menu .tab-menu-item.active {
        border-bottom: 2px solid #478dcd;
        color: #478dcd;
        cursor: default;
    }

    .play-icon {
        min-width: 30px;
        max-width: 30px;
        margin-left: auto;
    }

    .icon-play {
        min-width: 24px;
        max-width: 24px;
        height: 24px;
        display: flex;
        margin-left: auto;
        background: url(/images/play-button.svg) no-repeat center;
        background-size: contain;
    }

    .btn-favorite {
        padding:  0 20px !important;
        font-size: 21px;
        transition-duration: .3s;
    }
    .btn-default.btn-favorite {
        color: #478dcd;
    }


    .item-program {
        width: calc(100%/3) !important;
        margin: 0 !important;
        padding: 10px 15px !important;

        &:hover {
            background: rgba(0,0,0,0.1)
        }
    }
    .item-program:nth-child(3n) {
        border-left: 1px solid rgba(255, 255, 255, 0.3);
    }
    .item-program:nth-child(3n - 1) {
        border-left: 1px solid rgba(255, 255, 255, 0.3);
    }

    .light .item-program:nth-child(3n) {
        border-left: 1px solid #a9c8e6;
    }
    .light .item-program:nth-child(3n - 1) {
        border-left: 1px solid #a9c8e6;
    }

    .header-page {
        display: flex;
        align-items: center;
        justify-content: space-between;

        .title {
            width: initial;
            margin-right: 10px;
        }
    }

    @media (max-width: 1000px) {
        .item-program {
            width: calc(100%/2) !important;

        }
        .item-program:nth-child(3n) {
            border-left: 0;
        }
        .item-program:nth-child(3n - 1) {
            border-left: 0;
        }

        .item-program:nth-child(2n) {
            border-left: 1px solid rgba(255, 255, 255, 0.3);
        }
        .light .item-program:nth-child(2n) {
            border-left: 1px solid #a9c8e6;
        }
    }
    @media (max-width: 767px) {
        .item-program {
            width: calc(100%) !important;
        }

        .item-program:nth-child(2n) {
            border-left: 0;
        }
        .light .item-program:nth-child(2n) {
            border-left: 0;
        }
    }
</style>
